package com.bonait.bnframework.modules.home.fragment;


import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v4.content.ContextCompat;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.RelativeLayout;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.common.view.MyLayoutManager;
import com.bonait.bnframework.modules.home.adapter.lc_adapter;
import com.bonait.bnframework.modules.home.fragment.from.CpxzActivity;
import com.bonait.bnframework.modules.home.fragment.from.DiyActivity;
import com.bonait.bnframework.modules.home.fragment.mode.huoli_control;
import com.capton.colorfulprogressbar.ColorfulProgressbar;
import com.orhanobut.logger.Logger;
import com.qmuiteam.qmui.widget.QMUIProgressBar;
import com.qmuiteam.qmui.widget.QMUITopBar;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;
import com.qmuiteam.qmui.widget.textview.QMUILinkTextView;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * A simple {@link Fragment} subclass.
 */
public class Home1Fragment extends BaseFragment {
    @BindView(R.id.topbar)
    QMUITopBar mTopBar;//顶部标题
    @BindView(R.id.xzcp)
    RelativeLayout xzcp;//选择菜谱
    @BindView(R.id.recycler_view)
    RecyclerView recyclerView;//料仓列表
    @BindView(R.id.caipumingcheng)
    QMUILinkTextView caipumingcheng;//菜谱名称
    @BindView(R.id.shengyushijian)
    QMUILinkTextView shengyushijian;//剩余时间
    @BindView(R.id.jingdu)
    ColorfulProgressbar jingdu;//进度条
    @BindView(R.id.huoli)
    huoli_control huoli;//火力控件
    @BindView(R.id.startbutton)
    ImageView startbutton;//启动安
    public boolean Status=false;

    private Context context;

    public Home1Fragment() {
    }

    @Override
    protected View onCreateView() {
        View root = LayoutInflater.from(getActivity()).inflate(R.layout.fragment_home1, null);
        ButterKnife.bind(this, root);
        return root;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        context = getContext();
        initTopBar();
        initData();
        HuoLiClicked();
    }

    /**
     * 初始化TopBar
     */
    private void initTopBar() {
        jingdu.showPercentText(true);
        jingdu.setAnimation(true);
        jingdu.setProgress(0);
        jingdu.setSecondProgress(0);
        caipumingcheng.setText("");
        shengyushijian.setText("预计剩余时间：0s");
        startbutton.setImageResource(R.mipmap.qdzz);
        Status=false;

        mTopBar.setBackgroundColor(ContextCompat.getColor(requireContext(), R.color.app_color_theme_4));
        mTopBar.setTitle("菜谱烹饪");

    }

    /**
     * 初始化显示数据
     */
    private void initData() {
        try{
            MyLayoutManager layout = new MyLayoutManager();
            layout.setAutoMeasureEnabled(true);
            recyclerView.setLayoutManager(layout);

            DataBus.getInstance().lcadapter = new lc_adapter( getContext());
            recyclerView.setAdapter(DataBus.getInstance().lcadapter);

        }catch(Exception e){
            ToastUtils.info("异常信息:"+e.getMessage());
        }
    }

    /**
     * 火力按钮点击
     */
    public void HuoLiClicked()
    {
        huoli.mListener=new MyClickListener() {
            @Override
            public void clickListener(View v, Object data) {
                ToastUtils.info("火力按钮点击,当前级别："+data);
            }
        };

        DataBus.getInstance().mListener=new MyClickListener() {
            @Override
            public void clickListener(View v, Object data) {
                BPA_GOODS good=(BPA_GOODS)data;
                caipumingcheng.setText(good.name);
                shengyushijian.setText("预计剩余时间：300s");
            }
        };
    }

    @OnClick({R.id.xzcp,R.id.startbutton,R.id.qdjb,R.id.ztjb,R.id.tzjb
            ,R.id.ccw,R.id.chucw,R.id.dsw,R.id.yaoqian,R.id.tingyao})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.xzcp://选择菜谱按钮点击
                skipToActivity(CpxzActivity.class);
                ToastUtils.info("打开菜谱选择界面");
                break;
            case R.id.startbutton:
                if (Status)
                {
                    //按钮点击
                    String title = "停止操作提示！";
                    String message = "请问客官确定要停止制作吗,小菠萝会生气的,啊啊啊啊啊啊啊...我的饭饭？";
                    AlertDialogUtils.showDialog(context, title, message, new QMUIDialogAction.ActionListener() {
                        @Override
                        public void onClick(QMUIDialog dialog, int index) {
                            startbutton.setImageResource(R.mipmap.qdzz);
                            Status=false;
                            ToastUtils.info("点击停止制作按钮");
                            jingdu.setProgress(0);
                            jingdu.setSecondProgress(0);
                            shengyushijian.setText("预计剩余时间：0s");
                            dialog.dismiss();
                        }
                    });
                }else
                {
                    //按钮点击
                    String title = "开始操作提示！";
                    String message = "请问客官确定要开始制作吗,小菠萝好开心呀,马上就有好吃的耶？";
                    AlertDialogUtils.showDialog(context, title, message, new QMUIDialogAction.ActionListener() {
                        @Override
                        public void onClick(QMUIDialog dialog, int index) {
                            startbutton.setImageResource(R.mipmap.tzzz);
                            Status=true;
                            ToastUtils.info("点击启动制作按钮");
                            jingdu.setProgress(20);
                            jingdu.setSecondProgress(20);
                            shengyushijian.setText("预计剩余时间：300s");
                            dialog.dismiss();
                        }
                    });
                }
                break;
            case R.id.qdjb:
                ToastUtils.info("点击启动搅拌清洗按钮");
                break;
            case R.id.ztjb:
                ToastUtils.info("点击暂停清洗按钮");
                break;
            case R.id.tzjb:
                ToastUtils.info("点击停止清洗按钮");
                break;
            case R.id.ccw:
                ToastUtils.info("点击炒菜位按钮");
                break;
            case R.id.chucw:
                ToastUtils.info("点击出菜位按钮");
                break;
            case R.id.dsw:
                ToastUtils.info("点击倒水位按钮");
                break;
            case R.id.yaoqian:
                ToastUtils.info("点击摇浅按钮");
                break;
            case R.id.tingyao:
                ToastUtils.info("点击停摇按钮");
                break;
        }
    }

    /**
     * 跳转界面
     */
    private void skipToActivity(Class da) {
        // 跳转到登录页面
        Intent intent = new Intent(context, da);
        intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
        startActivity(intent);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        Logger.d("第一页销毁");
    }

    /**
     * 当在activity设置viewPager + BottomNavigation + fragment时，
     * 为防止viewPager左滑动切换界面，与fragment左滑返回上一界面冲突引起闪退问题，
     * 必须加上此方法，禁止fragment左滑返回上一界面。
     *
     * 切记！切记！切记！否则会闪退！
     *
     * 当在fragment设置viewPager + BottomNavigation + fragment时，则不会出现这个问题。
     * */
    @Override
    protected boolean canDragBack() {
        return false;
    }
}
