package com.bonait.bnframework.modules.home.fragment.from;

import static com.bonait.bnframework.MainApplication.getContext;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.GridLayoutManager;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.view.ViewGroup;
import android.view.animation.AnimationUtils;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.base.BaseActivity;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.modules.home.fragment.mode.QDListSectionAdapter;
import com.bonait.bnframework.modules.home.fragment.mode.SectionHeader;
import com.bonait.bnframework.modules.home.fragment.mode.SectionItem;
import com.orhanobut.logger.Logger;
import com.qmuiteam.qmui.widget.QMUITopBar;
import com.qmuiteam.qmui.widget.section.QMUISection;
import com.qmuiteam.qmui.widget.section.QMUIStickySectionAdapter;
import com.qmuiteam.qmui.widget.section.QMUIStickySectionLayout;

import java.util.ArrayList;

import butterknife.BindView;
import butterknife.ButterKnife;

public class CpActivity extends BaseActivity {

    @BindView(R.id.topbar)
    QMUITopBar mTopBar;

    @BindView(R.id.qmuisection_layout)
    QMUIStickySectionLayout mSectionLayout;
    private RecyclerView.LayoutManager mLayoutManager;
    protected static QMUIStickySectionAdapter<SectionHeader, SectionItem, QMUIStickySectionAdapter.ViewHolder> mAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_cp);
        //属性绑定
        ButterKnife.bind(this);
        initTopBar();
        initAdapter();
        initAdapterLogicalOperation();
    }

    private void initAdapter() {
        mLayoutManager = createLayoutManager();
        mSectionLayout.setLayoutManager(mLayoutManager);
        mAdapter = createAdapter();
        //mSectionLayout.setAnimation(AnimationUtils.loadAnimation(getContext(), R.anim.aword_fade_enter));
    }

    private void initAdapterLogicalOperation() {
        mAdapter.setCallback(new QMUIStickySectionAdapter.Callback<SectionHeader, SectionItem>() {
            @Override
            public void loadMore(final QMUISection<SectionHeader, SectionItem> section, final boolean loadMoreBefore) {
            }

            //点击事件
            @Override
            public void onItemClick(QMUIStickySectionAdapter.ViewHolder holder, int position) {
                if (holder.getItemViewType() != 1) {
                    int pos = holder.isForStickyHeader ? position : holder.getAdapterPosition();
                    mAdapter.toggleFold(pos, false);
                }
                ToastUtils.info(mAdapter.getItemIndex(position)+"");
            }

            //长按事件
            @Override
            public boolean onItemLongClick(QMUIStickySectionAdapter.ViewHolder holder, int position) {
                int FirstPos = mAdapter.getSectionIndex(position);
                int SecondPos = mAdapter.getItemIndex(position);
                //ItemPopupWindow.show(getContext(), holder.itemView, holder.getItemViewType(), FirstPos, SecondPos);
                ToastUtils.info("一级条目" +FirstPos+ "二级"+ SecondPos);
                return true;
            }
        });
        mSectionLayout.setAdapter(mAdapter, true);
        mAdapter.setData(getList());
    }

    protected QMUIStickySectionAdapter<SectionHeader, SectionItem, QMUIStickySectionAdapter.ViewHolder> createAdapter() {
        return new QDListSectionAdapter();
    }

    protected RecyclerView.LayoutManager createLayoutManager() {
//        return new LinearLayoutManager(getContext()) {
//            @Override
//            public RecyclerView.LayoutParams generateDefaultLayoutParams() {
//                return new RecyclerView.LayoutParams(
//                        ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
//            }
//        };
        final GridLayoutManager layoutManager = new GridLayoutManager(getContext(), 3);
        layoutManager.setSpanSizeLookup(new GridLayoutManager.SpanSizeLookup() {
            @Override
            public int getSpanSize(int i) {
                return mAdapter.getItemIndex(i) < 0 ? layoutManager.getSpanCount() : 1;
            }
        });
        return layoutManager;
    }

    private static ArrayList<QMUISection<SectionHeader, SectionItem>> getList() {
        ArrayList<QMUISection<SectionHeader, SectionItem>> list = new ArrayList<>();

        int n = 0;
        SectionHeader header = new SectionHeader("本地菜谱","","");
        ArrayList<SectionItem> contents = new ArrayList<>();
        for (int j = 0; j < 20/* 二级条目辅助数据*/; j++) {
            contents.add(new SectionItem("回锅肉"+j, "185" + n, "",j%4==0));
            n++;
        }
        QMUISection<SectionHeader, SectionItem> section = new QMUISection<>(header, contents, false);
        list.add(section);


        header = new SectionHeader("收藏菜谱","","");
        contents = new ArrayList<>();
        for (int j = 0; j < 20/* 二级条目辅助数据*/; j++) {
            contents.add(new SectionItem("回锅肉"+j, "185" + n, "",j%4==0));
            n++;
        }
        section = new QMUISection<>(header, contents, true);
        list.add(section);

        header = new SectionHeader("云端菜谱","","");
        contents = new ArrayList<>();
        for (int j = 0; j < 20/* 二级条目辅助数据*/; j++) {
            contents.add(new SectionItem("回锅肉"+j, "185" + n, "",j%4==0));
            n++;
        }
        section = new QMUISection<>(header, contents, true);
        list.add(section);
        return list;
    }

    private void initTopBar() {
        mTopBar.setTitle("菜谱管理");
        mTopBar.addLeftImageButton(R.mipmap.fanhui, R.id.topbar).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    @Override
    protected boolean canDragBack() {
        return false;
    }
}