package com.bonait.bnframework.modules.home.fragment.mode;


import android.content.Context;
import android.support.annotation.NonNull;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.qmuiteam.qmui.widget.section.QMUIDefaultStickySectionAdapter;
import com.qmuiteam.qmui.widget.section.QMUISection;

public class QDListSectionAdapter extends QMUIDefaultStickySectionAdapter {
    private TextView tvTag ,tvNote,tvAccount,Sc_text,delete_text;

    private RelativeLayout ImageUrl;//图片

    private ImageView sc_image;//是否收藏

    public boolean IsSC=false;

    @NonNull
    @Override
    protected ViewHolder onCreateSectionHeaderViewHolder(@NonNull ViewGroup viewGroup) {
        return new ViewHolder(new QDSectionHeaderView(viewGroup.getContext()));
    }
    public QDListSectionAdapter() {
    }

    @Override
    protected void onBindSectionHeader(final ViewHolder holder, final int position, QMUISection section) {

        QDSectionHeaderView itemView = (QDSectionHeaderView) holder.itemView;
        itemView.render((SectionHeader) section.getHeader(), section.isFold());
        //点击事件
        itemView.getArrowView().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int pos = holder.isForStickyHeader ? position : holder.getAdapterPosition();
                toggleFold(pos, false);
            }
        });
    }

    @Override
    protected void onBindSectionItem(ViewHolder holder, int position, QMUISection section, int itemIndex) {
        //获取id
        tvTag = holder.itemView.findViewById(R.id.Tag_text);
        tvNote = holder.itemView.findViewById(R.id.Note_text);
        Sc_text = holder.itemView.findViewById(R.id.Sc_text);
        delete_text = holder.itemView.findViewById(R.id.delete_text);
        sc_image=holder.itemView.findViewById(R.id.sc_image);//收藏
        ImageUrl=holder.itemView.findViewById(R.id.ImageUrl);//图片
        //设置文本

        String name=((SectionItem)section.getItemAt(itemIndex)).getTag();
        IsSC=((SectionItem)section.getItemAt(itemIndex)).getIsSC();
        tvTag.setText(name);
        tvNote.setText("时间："+ ((SectionItem)section.getItemAt(itemIndex)).getNote()+"秒");
        //设置图片
        ImageUrl.setBackground(holder.itemView.getContext().getResources().getDrawable(R.mipmap.hgr));
        Sc_text.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                ToastUtils.info("点击上传按钮,菜品:"+name);
            }
        });
        delete_text.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                ToastUtils.info("点击删除按钮,菜品:"+name);
            }
        });
        SetImage(sc_image,IsSC);
        sc_image.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                IsSC=!IsSC;
                SetImage(sc_image,IsSC);
            }
        });
    }

    public void SetImage(ImageView image,boolean isxz)
    {
        if(isxz)
        {
            image.setImageResource(R.mipmap.sc3);
        }else
        {
            image.setImageResource(R.mipmap.wsc3);
        }
    }

    @NonNull
    @Override
    protected ViewHolder onCreateSectionItemViewHolder(@NonNull ViewGroup viewGroup) {
        Context context = viewGroup.getContext();
        //这里是通过xml绑定布局，当然你也可以用代码new出来，方法请看头部视图
        View itemView = LayoutInflater.from(context).inflate(R.layout.note_rv_tree_second, viewGroup, false);
        return new ViewHolder(itemView);
    }
}